package dataspork.gui;
import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

public class SetEndCutoffGUI {

  protected JPanel mainPane;
  protected JPanel cutoffPane;
  protected JTextField cutoffField;
  protected JPanel scopePane;
  protected JComboBox scopeBox;
  protected JPanel scalarPane;
  protected JComboBox scalarBox;
  protected JPanel applyPane;
  protected JPanel closePane;
  protected JFrame mainFrame;
  protected MainGUI mGUI;

  public SetEndCutoffGUI(MainGUI mg) {
    
    mainFrame = new JFrame("Set End Cutoff");
    this.mGUI = mg;

    mainPane = new JPanel();
    mainPane.setLayout(new BoxLayout(mainPane,BoxLayout.Y_AXIS));
    mainPane.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));

    cutoffPane = new JPanel();
    cutoffPane.setLayout(new BoxLayout(cutoffPane,BoxLayout.X_AXIS));
    JLabel cutoffLabel = new JLabel("End Cutoff:");
    cutoffField = new JTextField(10);
    cutoffField.setText(Double.toString(mGUI.globalEndCutoff));
    cutoffField.setMaximumSize(new Dimension(250,40));
    cutoffPane.add(cutoffLabel);
    cutoffPane.add(Box.createRigidArea(new Dimension(5,0)));
    cutoffPane.add(Box.createHorizontalGlue());
    cutoffPane.add(cutoffField);

    scopePane = new JPanel();
    scopePane.setLayout(new BoxLayout(scopePane,BoxLayout.X_AXIS));
    JLabel scopeLabel = new JLabel("Tab:");
    String[] scopeItems = {"current","all"};
    scopeBox = new JComboBox(scopeItems);
    scopeBox.setEditable(false);
    scopePane.add(scopeLabel);
    scopePane.add(Box.createRigidArea(new Dimension(5,0)));
    scopePane.add(Box.createHorizontalGlue());
    scopePane.add(scopeBox);

    scalarPane = new JPanel();
    scalarPane.setLayout(new BoxLayout(scalarPane,BoxLayout.X_AXIS));
    JLabel scalarLabel = new JLabel("Scalar:");
    String[] scalarItems = {"current","all"};
    scalarBox = new JComboBox(scalarItems);
    scalarBox.setEditable(false);
    scalarPane.add(scalarLabel);
    scalarPane.add(Box.createRigidArea(new Dimension(5,0)));
    scalarPane.add(Box.createHorizontalGlue());
    scalarPane.add(scalarBox);

    applyPane = new JPanel();
    applyPane.setLayout(new BoxLayout(applyPane,BoxLayout.X_AXIS));
    JButton applyButton = new JButton("Apply");
    applyButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        try {
          double tempCut = Double.valueOf(cutoffField.getText()).doubleValue();
          String boxSelection = (String)scopeBox.getSelectedItem();
          boolean allTabs = true;
          if (boxSelection == "current") { allTabs = false; }
          String boxSelection2 = (String)scalarBox.getSelectedItem();
          boolean allScalars = true;
          if (boxSelection2 == "current") { allScalars = false; }
          mGUI.setEndCutoff(tempCut,allTabs,allScalars);

        }
        catch(NumberFormatException enum) {}
      }
    });
    applyPane.add(Box.createHorizontalGlue());
    applyPane.add(applyButton);

    closePane = new JPanel();
    closePane.setLayout(new BoxLayout(closePane,BoxLayout.X_AXIS));
    JButton closeButton = new JButton("Close");
    closeButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Runnable hideFrame = new Runnable() {
          public void run() {mainFrame.setVisible(false);}
        };
        SwingUtilities.invokeLater(hideFrame);
      }
    });
    closePane.add(Box.createHorizontalGlue());
    closePane.add(closeButton);

    mainPane.add(cutoffPane);
    mainPane.add(Box.createRigidArea(new Dimension(0,5)));
    mainPane.add(scopePane);
    mainPane.add(Box.createRigidArea(new Dimension(0,5)));
    mainPane.add(scalarPane);
    mainPane.add(Box.createRigidArea(new Dimension(0,10)));
    mainPane.add(Box.createVerticalGlue());
    mainPane.add(applyPane);
    mainPane.add(Box.createRigidArea(new Dimension(0,5)));
    mainPane.add(closePane);

    mainFrame.getContentPane().add(mainPane, BorderLayout.CENTER);

    mainFrame.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        Runnable hideFrame = new Runnable() {
          public void run() {mainFrame.setVisible(false);}
        };
        SwingUtilities.invokeLater(hideFrame);
      }
    });

    mainFrame.pack();
    mainFrame.show();

  }

}
