
package dataspork.gui;
import dataspork.util.grModel;
import dataspork.util.DataListener;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class grControl extends KeyAdapter
   implements ActionListener, FocusListener, DataListener {

   protected grModel grmodel;
   protected JTextField startField;
   protected JTextField drField;

   public grControl(grModel grm, JTextField startF, JTextField drF){

       grmodel = grm;
       startField = startF;
       drField = drF;
       setTextValues();
       startF.addActionListener(this);
       startF.addFocusListener(this);
       startF.addKeyListener(this);
       drF.addActionListener(this);
       drF.addFocusListener(this);
       drF.addKeyListener(this);

       grmodel.addListener(this);

   }
 
   protected void setTextValues(){
      startField.setText(Integer.toString(grmodel.getCutoff()));
      drField.setText(Double.toString(grmodel.getdr()));
   }   

   public void actionPerformed(ActionEvent event){
      if (event.getSource()==startField) {
         try{
          grmodel.setCutoff(Integer.valueOf(startField.getText()).intValue());
         } catch (NumberFormatException e){}
      }
      if (event.getSource()==drField) {
         try{
          grmodel.setdr(Double.valueOf(drField.getText()).doubleValue());
         } catch (NumberFormatException e){}
      }
      setTextValues();
   }

   public void focusLost(FocusEvent e){
      Object source = e.getSource();
      if (!e.isTemporary()) {
         actionPerformed(
           new ActionEvent(source,ActionEvent.ACTION_PERFORMED,null) ) ;
      }
   }

   public void focusGained(FocusEvent e){
   }

   public void keyTyped(KeyEvent k){
      int code = k.getKeyCode();
      if (code==k.VK_ENTER){ 
         actionPerformed(new
            ActionEvent(k.getSource(),ActionEvent.ACTION_PERFORMED,null) );
      }
   }

   public void dataChanged(Object o){
      setTextValues();
   }


}
