
package dataspork.gui;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import dataspork.view.*;
import dataspork.util.*;
import dataspork.plot.*;
import java.awt.event.*;
import dataspork.gui.CommonFrame;
import dataspork.gui.InterpreterGUI;
import dataspork.stat.skData;
import dataspork.interp.skFromConfig;
import dataspork.view.StructureFactorGraph;
import java.io.*;

public class skGUI extends CommonFrame
     implements InterpreterGUI, ActionListener, DataListener {

   protected StructureFactorGraph skGraph;
   protected PlotPanel skGraphPanel;
   protected skTextPanel controlPanel;
   protected JPanel cPanel;
   protected skData skd;
   protected skFromConfig gfc;

   public skGUI(skFromConfig gfc){
     this.gfc = gfc;

     setTitle(gfc.getName());

     JMenuUtil.addMenu(menuBar,"File",
                       new String[] {"Export to File","Close"}, 
                       new String[] {"exportfile","close"}, 
                       new int[] {KeyEvent.VK_S,KeyEvent.VK_W},
                       this);


     skd = gfc.getskData();

     skGraph =  new StructureFactorGraph(skd);

     skGraphPanel = new PlotPanel(skGraph.getPlot());
     skGraphPanel.setPreferredSize(new Dimension(400,250));
     skGraphPanel.setBackground(Color.white);
//     skGraphPanel.setBorder(new EmptyBorder(5,70,20,5));
     skGraphPanel.setBorder(
           BorderFactory.createTitledBorder(
             BorderFactory.createMatteBorder(10,50,30,10,Color.white),
             "Structure Factor S(k)",
             TitledBorder.CENTER,TitledBorder.BELOW_TOP));
          

     contentPane.setLayout(new BoxLayout(contentPane,BoxLayout.X_AXIS));
     contentPane.add(skGraphPanel);

     
     controlPanel = new skTextPanel(skd);     
     controlPanel.setBorder(CommonFrame.BORDER);


     cPanel = new JPanel();
     cPanel.setLayout(new BoxLayout(cPanel,BoxLayout.Y_AXIS));
     cPanel.add(controlPanel);
     cPanel.setBorder(new EmptyBorder(10,10,10,10));
     contentPane.add(cPanel);


     skd.addListener(this);

     pack();
     show();     
     
   }
   public void dataChanged(Object o){
      skGraphPanel.repaint();
   }

   public void actionPerformed(ActionEvent event){
      String command = event.getActionCommand();
      if (command.equals("close")) {
         Runnable hideFrame = new Runnable(){
            public void run() {setVisible(false); }
         };
      SwingUtilities.invokeLater(hideFrame);
      }

      if (command.equals("exportfile")){
        File file = new File(".");
        JFileChooser choosy = new JFileChooser(file);
        File defile = new File("sk.dat");
        choosy.setSelectedFile(defile);
        int state=choosy.showSaveDialog(this);
        if (state==choosy.APPROVE_OPTION) {
           File newfile = choosy.getSelectedFile();
           try {
             FileWriter fw = new FileWriter(choosy.getName(newfile));
             skd.write(fw);
             fw.close();
           } catch (IOException e) {
              System.out.println("Couldn't save to "+choosy.getName(newfile)
                                   +"\n");
           }
        }

       }
 
      
   }


}
