package dataspork.interp;
import dataspork.tree.DataTreeNode;
import dataspork.gui.InterpreterGUI;
import dataspork.gui.ScalarDatasetGUI;
import dataspork.stat.ScalarSeries;
import dataspork.util.DoubleWindowModel;
import java.util.Enumeration;

public class SetCutoff {

  protected DataTreeNode node;
  protected DataTreeNode leaf;

  public SetCutoff(DataTreeNode node) {
    this.node = node;
  }

  public void setGlobalStart(double cutoffValue, boolean allScalars, String lName) {

    ScalarDataset dset;
    DoubleWindowModel wind;
    Enumeration e = node.depthFirstEnumeration();
    while (e.hasMoreElements()) {
      leaf = (DataTreeNode)e.nextElement();
      if (leaf != null) {
        if (leaf.isLeaf()) {
          //leaf.getInterpreters();

          String leafName = leaf.toString();
          if (allScalars | leafName.equals(lName)) {


            Enumeration eInterp = leaf.getInterpreters();
            while (eInterp.hasMoreElements()) {
              InterpreterClass interp = (InterpreterClass)eInterp.nextElement();
              Interpreter in = interp.getInstance();
              if (in != null) {
                if (in.canReport()) {
                  dset = (ScalarDataset)in;
                  if (dset.hasData) {
                    wind = (DoubleWindowModel)dset.getWindow();
                    wind.setLow(cutoffValue);
                  }
                }
              }
            }
          }
        }
      }
    }
  }

  public void setGlobalEnd(double cutoffValue, boolean allScalars, String lName) {

    ScalarDataset dset;
    DoubleWindowModel wind;
    Enumeration e = node.depthFirstEnumeration();
    while (e.hasMoreElements()) {
      leaf = (DataTreeNode)e.nextElement();
      if (leaf != null) {
        if (leaf.isLeaf()) {
          //leaf.getInterpreters();

          String leafName = leaf.toString();
          if (allScalars | leafName.equals(lName)) {


            Enumeration eInterp = leaf.getInterpreters();
            while (eInterp.hasMoreElements()) {
              InterpreterClass interp = (InterpreterClass)eInterp.nextElement();
              Interpreter in = interp.getInstance();
              if (in != null) {
                if (in.canReport()) {
                  dset = (ScalarDataset)in;
                  if (dset.hasData) {
                    wind = (DoubleWindowModel)dset.getWindow();
                    wind.setHigh(cutoffValue);
                  }
                }
              }
            }
          }
        }
      }
    }
  }

}

