
package dataspork.util;

import javax.swing.event.EventListenerList;
import java.util.EventListener;
import dataspork.util.DataListener;

/** Model for storing the number of k-shells and the beginning 
     configuration cutoff for S(k). */

public class skModel {

   protected int kshell;
   protected int cutoff;
   protected int cutoff_max;
   protected EventListenerList listenerList;

   public skModel (int kshell, int cutoff, int cutmax) {
       this.kshell = kshell;
       this.cutoff = cutoff;
       cutoff_max = cutmax;
       listenerList = new EventListenerList();
   }

   public int getKShell(){
      return kshell;
   }

   public int getCutoff(){
      return cutoff;
   }

   public void setKShell(int ks){
       int oldks;
       oldks = this.kshell;
       if (ks>0.0)  { this.kshell = ks;}

       if (oldks!=ks) {
          fireListeners();
       }
   }
   public void setCutoff(int cut){
       int oldcut = this.cutoff;
       if (cut>=0 )  { this.cutoff = cut;}
       if ( (cut>cutoff_max) && (cutoff_max!=0))  {this.cutoff=cutoff_max;}

       if (oldcut!=cut) {
          fireListeners();
       }
   }
   public void addListener(DataListener e){
      listenerList.add(DataListener.class,e);
   }

   protected void fireListeners(){
      Object[] listeners  = listenerList.getListenerList();
      for (int i=listeners.length-2;i>=0; i-=2){
         ((DataListener)listeners[i+1]).dataChanged(this);
      }
   }




}
