package pupi.reader.restart;
import dataspork.tree.DataSource;
import java.util.*;
import ncsa.hdf.hdflib.*;

public class VectorSource implements DataSource {

  protected int[] dims;
  protected double[] data;
  protected String filename;
  protected HDFLibrary hdf;
  protected int tag;
  protected int ref;

  public VectorSource(HDFParser.Element e) {
    data=null;
    dims=null;
    filename=e.getFilename();
    hdf=e.getHDFLibrary();
    tag=e.tag;
    ref=e.ref;
  }

  public Object getData() {
    if (data==null) {
      //Read the data from the HDF file.
      try {
        int fileID = hdf.Hopen(filename);
        hdf.Vstart(fileID);
        int iread=0;
        int length = hdf.Hlength(fileID,tag,ref);
        byte[] buf = new byte[length];
        hdf.Hgetelement(fileID,tag,ref,buf);
        byte[] buf2 = new byte[length-4];
        for (int i=0; i<buf2.length; i++) buf2[i]=buf[i+4];
        data = HDFNativeData.byteToDouble(buf2);
        hdf.Vend(fileID);
        hdf.Hclose(fileID);
        dims = new int[1]; dims[0]=data.length;
      }
      catch (Throwable t) {t.printStackTrace();}
    }
    return data;
  }

  public int[] getDims() {
    if (dims==null) getData();
    return dims;
  }

  public int getType() {
    return DOUBLE;
  }
}
